import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue,
} from "@/components/ui/select";
import { useEffect, useState } from "react";

type Props = {
  setCurrentDMNName: any;
};

export function SelectDMN({ setCurrentDMNName }: Props) {
  const [allDMNNames, setAllDMNNames] = useState<Array<string>>([]);

  async function getAllDMNNames() {
    const response = await fetch("http://localhost:8080/getAllDMNNames");
    setAllDMNNames(await response.json());
  }

  useEffect(() => {
    getAllDMNNames();
  }, []);

  return (
    <Select
      onValueChange={(value: string) => {
        setCurrentDMNName(value);
      }}
    >
      <SelectTrigger className="w-[180px]">
        <SelectValue placeholder="DMN" />
      </SelectTrigger>
      <SelectContent>
        {allDMNNames.map((DMNName: string) => {
          return (
            <SelectItem value={DMNName}>
              {DMNName}
            </SelectItem>
          );
        })}
      </SelectContent>
    </Select>
  );
}
